Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp	(revision 87858)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp	(revision 87859)
@@ -18,5 +18,5 @@
 /* Qt includes: */
 #include <QVariant>
-
+#include <QPushButton>
 /* GUI includes: */
 #include "UICommon.h"
@@ -49,4 +49,7 @@
     assignBackground(":/wizard_new_harddisk_bg.png");
 #endif /* VBOX_WS_MAC */
+    QPushButton *pButton = new QPushButton("boooo");
+    setSideWidget(pButton);
+
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic1.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic1.cpp	(revision 87858)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic1.cpp	(revision 87859)
@@ -145,4 +145,15 @@
 }
 
+void UIWizardNewVDPage1::retranslateWidgets()
+{
+    QList<QAbstractButton*> buttons = m_pFormatButtonGroup->buttons();
+    for (int i = 0; i < buttons.size(); ++i)
+    {
+        QAbstractButton *pButton = buttons[i];
+        UIMediumFormat enmFormat = gpConverter->fromInternalString<UIMediumFormat>(m_formatNames[m_pFormatButtonGroup->id(pButton)]);
+        pButton->setText(gpConverter->toString(enmFormat));
+    }
+}
+
 UIWizardNewVDPageBasic1::UIWizardNewVDPageBasic1()
 {
@@ -169,6 +180,7 @@
 void UIWizardNewVDPageBasic1::retranslateUi()
 {
+    retranslateWidgets();
     /* Translate page: */
-    setTitle(UIWizardNewVD::tr("Hard disk file type"));
+    setTitle(UIWizardNewVD::tr("Virtual Hard disk file type"));
 
     /* Translate widgets: */
@@ -176,11 +188,4 @@
                                         "for the new virtual hard disk. If you do not need to use it "
                                         "with other virtualization software you can leave this setting unchanged."));
-    QList<QAbstractButton*> buttons = m_pFormatButtonGroup->buttons();
-    for (int i = 0; i < buttons.size(); ++i)
-    {
-        QAbstractButton *pButton = buttons[i];
-        UIMediumFormat enmFormat = gpConverter->fromInternalString<UIMediumFormat>(m_formatNames[m_pFormatButtonGroup->id(pButton)]);
-        pButton->setText(gpConverter->toString(enmFormat));
-    }
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic1.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic1.h	(revision 87858)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic1.h	(revision 87859)
@@ -52,4 +52,5 @@
     CMediumFormat mediumFormat() const;
     void setMediumFormat(const CMediumFormat &mediumFormat);
+    void retranslateWidgets();
 
     /* Variables: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic2.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic2.cpp	(revision 87858)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic2.cpp	(revision 87859)
@@ -72,4 +72,11 @@
 }
 
+void UIWizardNewVDPage2::retranslateWidgets()
+{
+    m_pDynamicalButton->setText(UIWizardNewVD::tr("&Dynamically allocated"));
+    m_pFixedButton->setText(UIWizardNewVD::tr("&Fixed size"));
+    m_pSplitBox->setText(UIWizardNewVD::tr("&Split into files of less than 2GB"));
+}
+
 UIWizardNewVDPageBasic2::UIWizardNewVDPageBasic2()
 {
@@ -119,4 +126,5 @@
 void UIWizardNewVDPageBasic2::retranslateUi()
 {
+    retranslateWidgets();
     /* Translate page: */
     setTitle(UIWizardNewVD::tr("Storage on physical hard disk"));
@@ -134,7 +142,4 @@
                                              "virtual machine on removable USB devices or old systems, some of which cannot "
                                              "handle very large files."));
-    m_pDynamicalButton->setText(UIWizardNewVD::tr("&Dynamically allocated"));
-    m_pFixedButton->setText(UIWizardNewVD::tr("&Fixed size"));
-    m_pSplitBox->setText(UIWizardNewVD::tr("&Split into files of less than 2GB"));
 }
 
@@ -168,3 +173,2 @@
     return mediumVariant() != (qulonglong)KMediumVariant_Max;
 }
-
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic2.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic2.h	(revision 87858)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic2.h	(revision 87859)
@@ -43,4 +43,5 @@
     qulonglong mediumVariant() const;
     void setMediumVariant(qulonglong uMediumVariant);
+    void retranslateWidgets();
 
     /* Widgets: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic3.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic3.cpp	(revision 87858)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic3.cpp	(revision 87859)
@@ -52,4 +52,8 @@
     , m_uMediumSizeMin(_4M)
     , m_uMediumSizeMax(uiCommon().virtualBox().GetSystemProperties().GetInfoVDSize())
+    , m_pLocationEditor(0)
+    , m_pLocationOpenButton(0)
+    , m_pEditorSize(0)
+
 {
 }
@@ -102,7 +106,10 @@
         if (QFileInfo(strChosenFilePath).suffix().isEmpty())
             strChosenFilePath += QString(".%1").arg(m_strDefaultExtension);
-        m_pLocationEditor->setText(QDir::toNativeSeparators(strChosenFilePath));
-        m_pLocationEditor->selectAll();
-        m_pLocationEditor->setFocus();
+        if (m_pLocationEditor)
+        {
+            m_pLocationEditor->setText(QDir::toNativeSeparators(strChosenFilePath));
+            m_pLocationEditor->selectAll();
+            m_pLocationEditor->setFocus();
+        }
     }
 }
@@ -200,4 +207,6 @@
 QString UIWizardNewVDPage3::mediumPath() const
 {
+    if (!m_pLocationEditor)
+        return QString();
     return absoluteFilePath(toFileName(m_pLocationEditor->text(), m_strDefaultExtension), m_strDefaultPath);
 }
@@ -205,10 +214,17 @@
 qulonglong UIWizardNewVDPage3::mediumSize() const
 {
-    return m_pEditorSize->mediumSize();
+    return m_pEditorSize ? m_pEditorSize->mediumSize() : 0;
 }
 
 void UIWizardNewVDPage3::setMediumSize(qulonglong uMediumSize)
 {
-    m_pEditorSize->setMediumSize(uMediumSize);
+    if (m_pEditorSize)
+        m_pEditorSize->setMediumSize(uMediumSize);
+}
+
+void UIWizardNewVDPage3::retranslateWidgets()
+{
+    if (m_pLocationOpenButton)
+        m_pLocationOpenButton->setToolTip(UIWizardNewVD::tr("Choose a location for new virtual hard disk file..."));
 }
 
@@ -259,4 +275,5 @@
 void UIWizardNewVDPageBasic3::retranslateUi()
 {
+    retranslateWidgets();
     /* Translate page: */
     setTitle(UIWizardNewVD::tr("File location and size"));
@@ -265,8 +282,8 @@
     m_pLocationLabel->setText(UIWizardNewVD::tr("Please type the name of the new virtual hard disk file into the box below or "
                                                 "click on the folder icon to select a different folder to create the file in."));
-    m_pLocationOpenButton->setToolTip(UIWizardNewVD::tr("Choose a location for new virtual hard disk file..."));
-    m_pSizeLabel->setText(UIWizardNewVD::tr("Select the size of the virtual hard disk in megabytes. "
-                                            "This size is the limit on the amount of file data "
-                                            "that a virtual machine will be able to store on the hard disk."));
+    if (m_pSizeLabel)
+        m_pSizeLabel->setText(UIWizardNewVD::tr("Select the size of the virtual hard disk in megabytes. "
+                                                "This size is the limit on the amount of file data "
+                                                "that a virtual machine will be able to store on the hard disk."));
 }
 
@@ -279,9 +296,12 @@
     m_strDefaultExtension = defaultExtension(field("mediumFormat").value<CMediumFormat>());
     /* Set default name as text for location editor: */
-    m_pLocationEditor->setText(absoluteFilePath(m_strDefaultName, m_strDefaultPath, m_strDefaultExtension));
+    if (m_pLocationEditor)
+        m_pLocationEditor->setText(absoluteFilePath(m_strDefaultName, m_strDefaultPath, m_strDefaultExtension));
 }
 
 bool UIWizardNewVDPageBasic3::isComplete() const
 {
+    if (!m_pLocationEditor)
+        return false;
     /* Make sure current name is not empty and current size feats the bounds: */
     return !m_pLocationEditor->text().trimmed().isEmpty() &&
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic3.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic3.h	(revision 87858)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic3.h	(revision 87859)
@@ -65,4 +65,5 @@
     qulonglong mediumSize() const;
     void setMediumSize(qulonglong uMediumSize);
+    void retranslateWidgets();
 
     /* Variables: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageExpert.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageExpert.cpp	(revision 87858)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageExpert.cpp	(revision 87859)
@@ -197,9 +197,10 @@
 void UIWizardNewVDPageExpert::retranslateUi()
 {
+    UIWizardNewVDPage1::retranslateWidgets();
+    UIWizardNewVDPage2::retranslateWidgets();
+    UIWizardNewVDPage3::retranslateWidgets();
     /* Translate widgets: */
     if (m_pLocationGroupBox)
         m_pLocationGroupBox->setTitle(UIWizardNewVD::tr("File &location"));
-    if (m_pLocationOpenButton)
-        m_pLocationOpenButton->setToolTip(UIWizardNewVD::tr("Choose a location for new virtual hard disk file..."));
     if (m_pSizeGroupBox)
         m_pSizeGroupBox->setTitle(UIWizardNewVD::tr("File &size"));